Index: trunk/source/persistency/gdml/src/G4GDMLReadStructure.cc
===================================================================
--- trunk/source/persistency/gdml/src/G4GDMLReadStructure.cc	(revision 1227)
+++ trunk/source/persistency/gdml/src/G4GDMLReadStructure.cc	(revision 1228)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4GDMLReadStructure.cc,v 1.56 2009/02/24 17:41:44 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// $Id: G4GDMLReadStructure.cc,v 1.62 2009/09/24 15:04:34 gcosmo Exp $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // class G4GDMLReadStructure Implementation
@@ -35,4 +35,24 @@
 #include "G4GDMLReadStructure.hh"
 
+#include "G4LogicalVolume.hh"
+#include "G4VPhysicalVolume.hh"
+#include "G4PVPlacement.hh"
+#include "G4LogicalVolumeStore.hh"
+#include "G4PhysicalVolumeStore.hh"
+#include "G4AssemblyVolume.hh"
+#include "G4ReflectionFactory.hh"
+#include "G4PVDivisionFactory.hh"
+#include "G4LogicalBorderSurface.hh"
+#include "G4LogicalSkinSurface.hh"
+#include "G4VisAttributes.hh"
+
+G4GDMLReadStructure::G4GDMLReadStructure() : G4GDMLReadParamvol()
+{
+}
+
+G4GDMLReadStructure::~G4GDMLReadStructure()
+{
+}
+
 G4GDMLAuxPairType G4GDMLReadStructure::
 AuxiliaryRead(const xercesc::DOMElement* const auxiliaryElement)
@@ -65,5 +85,5 @@
 
 void G4GDMLReadStructure::
-BordersurfaceRead(const xercesc::DOMElement* const bordersurfaceElement)
+BorderSurfaceRead(const xercesc::DOMElement* const bordersurfaceElement)
 {
    G4String name;
@@ -255,8 +275,10 @@
 
 void G4GDMLReadStructure::
-PhysvolRead(const xercesc::DOMElement* const physvolElement)
+PhysvolRead(const xercesc::DOMElement* const physvolElement,
+            G4AssemblyVolume* pAssembly)
 {
    G4String name;
    G4LogicalVolume* logvol = 0;
+   G4AssemblyVolume* assembly = 0;
    G4ThreeVector position(0.0,0.0,0.0);
    G4ThreeVector rotation(0.0,0.0,0.0);
@@ -270,15 +292,15 @@
         attribute_index<attributeCount; attribute_index++)
    {
-      xercesc::DOMNode* attribute_node = attributes->item(attribute_index);
-
-      if (attribute_node->getNodeType() != xercesc::DOMNode::ATTRIBUTE_NODE)
-        { continue; }
-
-      const xercesc::DOMAttr* const attribute
-            = dynamic_cast<xercesc::DOMAttr*>(attribute_node);   
-      const G4String attName = Transcode(attribute->getName());
-      const G4String attValue = Transcode(attribute->getValue());
-
-      if (attName=="name") { name = attValue; }
+     xercesc::DOMNode* attribute_node = attributes->item(attribute_index);
+
+     if (attribute_node->getNodeType() != xercesc::DOMNode::ATTRIBUTE_NODE)
+       { continue; }
+
+     const xercesc::DOMAttr* const attribute
+           = dynamic_cast<xercesc::DOMAttr*>(attribute_node);   
+     const G4String attName = Transcode(attribute->getName());
+     const G4String attValue = Transcode(attribute->getValue());
+
+     if (attName=="name") { name = attValue; }
    }
 
@@ -286,32 +308,36 @@
         iter != 0; iter = iter->getNextSibling())
    {
-      if (iter->getNodeType() != xercesc::DOMNode::ELEMENT_NODE)  { continue; }
-
-      const xercesc::DOMElement* const child
-            = dynamic_cast<xercesc::DOMElement*>(iter);
-      const G4String tag = Transcode(child->getTagName());
-
-      if (tag=="file")
-        { logvol = FileRead(child); } else
-      if (tag=="volumeref")
-        { logvol = GetVolume(GenerateName(RefRead(child))); } else
-      if (tag=="position")
-        { VectorRead(child,position); } else
-      if (tag=="rotation")
-        { VectorRead(child,rotation); } else
-      if (tag=="scale")
-        { VectorRead(child,scale); } else
-      if (tag=="positionref")
-        { position = GetPosition(GenerateName(RefRead(child))); } else
-      if (tag=="rotationref")
-        { rotation = GetRotation(GenerateName(RefRead(child))); } else
-      if (tag=="scaleref")
+     if (iter->getNodeType() != xercesc::DOMNode::ELEMENT_NODE)  { continue; }
+
+     const xercesc::DOMElement* const child
+           = dynamic_cast<xercesc::DOMElement*>(iter);
+     const G4String tag = Transcode(child->getTagName());
+
+     if (tag=="volumeref")
+       {
+         const G4String& child_name = GenerateName(RefRead(child));
+         assembly = GetAssembly(child_name);
+         if (!assembly) { logvol = GetVolume(child_name); }
+       }
+     else if (tag=="file")
+       { logvol = FileRead(child); }
+     else if (tag=="position")
+       { VectorRead(child,position); }
+     else if (tag=="rotation")
+       { VectorRead(child,rotation); }
+     else if (tag=="scale")
+       { VectorRead(child,scale); }
+     else if (tag=="positionref")
+       { position = GetPosition(GenerateName(RefRead(child))); }
+     else if (tag=="rotationref")
+        { rotation = GetRotation(GenerateName(RefRead(child))); }
+     else if (tag=="scaleref")
         { scale = GetScale(GenerateName(RefRead(child))); }
-      else
-      {
-        G4String error_msg = "Unknown tag in physvol: " + tag;
-        G4Exception("G4GDMLReadStructure::PhysvolRead()", "ReadError",
-                    FatalException, error_msg);
-      }
+     else
+        {
+          G4String error_msg = "Unknown tag in physvol: " + tag;
+          G4Exception("G4GDMLReadStructure::PhysvolRead()", "ReadError",
+                      FatalException, error_msg);
+        }
    }
 
@@ -319,10 +345,24 @@
    transform = transform*G4Scale3D(scale.x(),scale.y(),scale.z());
 
-   G4String pv_name = logvol->GetName() + "_PV";
-   G4PhysicalVolumesPair pair = G4ReflectionFactory::Instance()
-     ->Place(transform,pv_name,logvol,pMotherLogical,false,0,check);
-
-   if (pair.first != 0) { GeneratePhysvolName(name,pair.first); }
-   if (pair.second != 0) { GeneratePhysvolName(name,pair.second); }
+   if (pAssembly)   // Fill assembly structure
+   {
+     pAssembly->AddPlacedVolume(logvol, transform);
+   }
+   else             // Generate physical volume tree or do assembly imprint
+   {
+     if (assembly)
+     {
+       assembly->MakeImprint(pMotherLogical, transform, 0, check);
+     }
+     else
+     {
+       G4String pv_name = logvol->GetName() + "_PV";
+       G4PhysicalVolumesPair pair = G4ReflectionFactory::Instance()
+         ->Place(transform,pv_name,logvol,pMotherLogical,false,0,check);
+
+       if (pair.first != 0) { GeneratePhysvolName(name,pair.first); }
+       if (pair.second != 0) { GeneratePhysvolName(name,pair.second); }
+     }
+   }
 }
 
@@ -510,5 +550,35 @@
 
 void G4GDMLReadStructure::
-SkinsurfaceRead(const xercesc::DOMElement* const skinsurfaceElement)
+AssemblyRead(const xercesc::DOMElement* const assemblyElement)
+{
+   XMLCh *name_attr = xercesc::XMLString::transcode("name");
+   const G4String name = Transcode(assemblyElement->getAttribute(name_attr));
+   xercesc::XMLString::release(&name_attr);
+
+   G4AssemblyVolume* pAssembly = new G4AssemblyVolume();
+   assemblyMap.insert(std::make_pair(GenerateName(name), pAssembly));
+
+   for (xercesc::DOMNode* iter = assemblyElement->getFirstChild();
+        iter != 0; iter = iter->getNextSibling())
+   {
+      if (iter->getNodeType() != xercesc::DOMNode::ELEMENT_NODE) { continue; }
+      const xercesc::DOMElement* const child
+            = dynamic_cast<xercesc::DOMElement*>(iter);
+      const G4String tag = Transcode(child->getTagName());
+
+      if (tag=="physvol")
+      {
+        PhysvolRead(child, pAssembly);
+      }
+      else
+      {
+        G4cout << "Unsupported GDML tag '" << tag
+               << "' for Geant4 assembly structure !" << G4endl;
+      }
+   }
+}
+
+void G4GDMLReadStructure::
+SkinSurfaceRead(const xercesc::DOMElement* const skinsurfaceElement)
 {
    G4String name;
@@ -643,7 +713,8 @@
       const G4String tag = Transcode(child->getTagName());
 
-      if (tag=="bordersurface") { BordersurfaceRead(child); } else
-      if (tag=="skinsurface") { SkinsurfaceRead(child); } else
+      if (tag=="bordersurface") { BorderSurfaceRead(child); } else
+      if (tag=="skinsurface") { SkinSurfaceRead(child); } else
       if (tag=="volume") { VolumeRead(child); } else
+      if (tag=="assembly") { AssemblyRead(child); } else
       if (tag=="loop") { LoopRead(child,&G4GDMLRead::StructureRead); }
       else
@@ -688,8 +759,17 @@
 }
 
+G4AssemblyVolume* G4GDMLReadStructure::
+GetAssembly(const G4String& ref) const
+{
+   G4GDMLAssemblyMapType::const_iterator pos = assemblyMap.find(ref);
+   if (pos != assemblyMap.end()) { return pos->second; }
+   return 0;
+}
+
 G4GDMLAuxListType G4GDMLReadStructure::
 GetVolumeAuxiliaryInformation(const G4LogicalVolume* const logvol)
 {
-   if (auxMap.find(logvol) != auxMap.end()) { return auxMap[logvol]; }
+   G4GDMLAuxMapType::const_iterator pos = auxMap.find(logvol);
+   if (pos != auxMap.end()) { return pos->second; }
    else { return G4GDMLAuxListType(); }
 }
Index: trunk/source/persistency/gdml/src/G4GDMLWrite.cc
===================================================================
--- trunk/source/persistency/gdml/src/G4GDMLWrite.cc	(revision 1227)
+++ trunk/source/persistency/gdml/src/G4GDMLWrite.cc	(revision 1228)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4GDMLWrite.cc,v 1.50 2008/11/13 17:00:50 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// $Id: G4GDMLWrite.cc,v 1.55 2009/04/24 15:34:20 gcosmo Exp $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // class G4GDMLWrite Implementation
@@ -34,7 +34,22 @@
 // --------------------------------------------------------------------
 
+#include <sys/stat.h>
+#include <iostream>
+
 #include "G4GDMLWrite.hh"
 
+#include "G4LogicalVolume.hh"
+#include "G4Transform3D.hh"
+#include "G4PVDivision.hh"
+
 G4bool G4GDMLWrite::addPointerToName = true;
+
+G4GDMLWrite::G4GDMLWrite() : extElement(0)
+{
+}
+
+G4GDMLWrite::~G4GDMLWrite()
+{
+}
 
 G4bool G4GDMLWrite::FileExists(const G4String& fname) const
@@ -62,9 +77,27 @@
 }
 
+void G4GDMLWrite::AddExtension(xercesc::DOMElement*,
+                               const G4LogicalVolume* const)
+{
+   // Empty implementation. To be overwritten by user for specific extensions
+   // related to attributes associated to volumes
+}
+
+void G4GDMLWrite::ExtensionWrite(xercesc::DOMElement*)
+{
+   // Empty implementation. To be overwritten by user for specific extensions
+}
+
 G4String G4GDMLWrite::GenerateName(const G4String& name, const void* const ptr)
 {
+   G4String nameOut;
    std::stringstream stream; stream << name;
-   if (addPointerToName) { stream << ptr; }
-   return G4String(stream.str());
+   if (addPointerToName) { stream << ptr; };
+
+   nameOut=G4String(stream.str());
+   if(nameOut.contains(' '))
+   nameOut.erase(std::remove(nameOut.begin(),nameOut.end(),' '),nameOut.end());
+
+   return nameOut;
 }
 
@@ -153,4 +186,5 @@
                           SchemaLocation));
 
+   ExtensionWrite(gdml);
    DefineWrite(gdml);
    MaterialsWrite(gdml);
@@ -161,4 +195,5 @@
    G4Transform3D R = TraverseVolumeTree(logvol,depth);
 
+   SurfacesWrite();
    xercesc::XMLFormatTarget *myFormTarget =
      new xercesc::LocalFileFormatTarget(fname.c_str());
Index: trunk/source/persistency/gdml/src/G4GDMLWriteDefine.cc
===================================================================
--- trunk/source/persistency/gdml/src/G4GDMLWriteDefine.cc	(revision 1227)
+++ trunk/source/persistency/gdml/src/G4GDMLWriteDefine.cc	(revision 1228)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4GDMLWriteDefine.cc,v 1.18 2008/07/16 15:46:34 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// $Id: G4GDMLWriteDefine.cc,v 1.19 2009/03/24 15:47:33 gcosmo Exp $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // class G4GDMLWriteDefine Implementation
@@ -39,4 +39,12 @@
 const G4double G4GDMLWriteDefine::kAngularPrecision = DBL_EPSILON;
 const G4double G4GDMLWriteDefine::kLinearPrecision = DBL_EPSILON;
+
+G4GDMLWriteDefine::G4GDMLWriteDefine() : G4GDMLWrite()
+{
+}
+
+G4GDMLWriteDefine::~G4GDMLWriteDefine()
+{
+}
 
 G4ThreeVector G4GDMLWriteDefine::GetAngles(const G4RotationMatrix& mat)
Index: trunk/source/persistency/gdml/src/G4GDMLWriteMaterials.cc
===================================================================
--- trunk/source/persistency/gdml/src/G4GDMLWriteMaterials.cc	(revision 1227)
+++ trunk/source/persistency/gdml/src/G4GDMLWriteMaterials.cc	(revision 1228)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4GDMLWriteMaterials.cc,v 1.20 2008/07/16 15:46:34 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// $Id: G4GDMLWriteMaterials.cc,v 1.24 2009/04/27 07:22:36 gcosmo Exp $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // class G4GDMLWriteMaterials Implementation
@@ -34,5 +34,20 @@
 // --------------------------------------------------------------------
 
+#include <sstream>
 #include "G4GDMLWriteMaterials.hh"
+
+#include "G4Element.hh"
+#include "G4Isotope.hh"
+#include "G4Material.hh"
+
+G4GDMLWriteMaterials::
+G4GDMLWriteMaterials() : G4GDMLWriteDefine()
+{
+}
+
+G4GDMLWriteMaterials::
+~G4GDMLWriteMaterials()
+{
+}
 
 void G4GDMLWriteMaterials::
@@ -134,4 +149,11 @@
    materialElement->setAttributeNode(NewAttribute("state",state_str));
 
+   // Write any property attached to the material...
+   //
+   if (materialPtr->GetMaterialPropertiesTable())
+   {
+     PropertyWrite(materialElement, materialPtr);
+   }
+
    if (materialPtr->GetTemperature() != STP_Temperature)
      { TWrite(materialElement,materialPtr->GetTemperature()); }
@@ -165,6 +187,59 @@
    }
 
+   // Append the material AFTER all the possible components are appended!
+   //
    materialsElement->appendChild(materialElement);
-     // Append the material AFTER all the possible components are appended!
+}
+
+void G4GDMLWriteMaterials::PropertyVectorWrite(const G4String& key,
+                           const G4MaterialPropertyVector* const pvec)
+{
+   xercesc::DOMElement* matrixElement = NewElement("matrix");
+   matrixElement->setAttributeNode(NewAttribute("name", key));
+   matrixElement->setAttributeNode(NewAttribute("coldim", "2"));
+   std::ostringstream pvalues;
+   for (G4int i=0; i<pvec->Entries(); i++)
+   {
+     G4MPVEntry cval = pvec->GetEntry(i);
+     if (i!=0)  { pvalues << " "; }
+     pvalues << cval.GetPhotonEnergy() << " " << cval.GetProperty();
+   }
+   matrixElement->setAttributeNode(NewAttribute("values", pvalues.str()));
+
+   defineElement->appendChild(matrixElement);
+}
+
+void G4GDMLWriteMaterials::PropertyWrite(xercesc::DOMElement* matElement,
+                                         const G4Material* const mat)
+{
+   xercesc::DOMElement* propElement;
+   G4MaterialPropertiesTable* ptable = mat->GetMaterialPropertiesTable();
+   const std::map< G4String, G4MaterialPropertyVector*,
+                 std::less<G4String> >* pmap = ptable->GetPropertiesMap();
+   const std::map< G4String, G4double,
+                 std::less<G4String> >* cmap = ptable->GetPropertiesCMap();
+   std::map< G4String, G4MaterialPropertyVector*,
+                 std::less<G4String> >::const_iterator mpos;
+   std::map< G4String, G4double,
+                 std::less<G4String> >::const_iterator cpos;
+   for (mpos=pmap->begin(); mpos!=pmap->end(); mpos++)
+   {
+      propElement = NewElement("property");
+      propElement->setAttributeNode(NewAttribute("name", mpos->first));
+      propElement->setAttributeNode(NewAttribute("ref", mpos->first));
+      PropertyVectorWrite(mpos->first, mpos->second);
+      matElement->appendChild(propElement);
+   }
+   for (cpos=cmap->begin(); cpos!=cmap->end(); cpos++)
+   {
+      propElement = NewElement("property");
+      propElement->setAttributeNode(NewAttribute("name", cpos->first));
+      propElement->setAttributeNode(NewAttribute("ref", cpos->first));
+      xercesc::DOMElement* constElement = NewElement("constant");
+      constElement->setAttributeNode(NewAttribute("name", cpos->first));
+      constElement->setAttributeNode(NewAttribute("value", cpos->second));
+      defineElement->appendChild(constElement);
+      matElement->appendChild(propElement);
+   }
 }
 
Index: trunk/source/persistency/gdml/src/G4GDMLWriteParamvol.cc
===================================================================
--- trunk/source/persistency/gdml/src/G4GDMLWriteParamvol.cc	(revision 1227)
+++ trunk/source/persistency/gdml/src/G4GDMLWriteParamvol.cc	(revision 1228)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4GDMLWriteParamvol.cc,v 1.23 2008/08/20 08:56:32 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// $Id: G4GDMLWriteParamvol.cc,v 1.25 2009/04/24 15:34:20 gcosmo Exp $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // class G4GDMLParamVol Implementation
@@ -35,5 +35,29 @@
 
 #include "G4GDMLWriteParamvol.hh"
-#include <sstream>
+
+#include "G4Box.hh"
+#include "G4Trd.hh"
+#include "G4Trap.hh"
+#include "G4Tubs.hh"
+#include "G4Cons.hh"
+#include "G4Sphere.hh"
+#include "G4Orb.hh"
+#include "G4Torus.hh"
+#include "G4Para.hh"
+#include "G4Hype.hh"
+#include "G4LogicalVolume.hh"
+#include "G4VPhysicalVolume.hh"
+#include "G4PVParameterised.hh"
+#include "G4VPVParameterisation.hh"
+
+G4GDMLWriteParamvol::
+G4GDMLWriteParamvol() : G4GDMLWriteSetup()
+{
+}
+
+G4GDMLWriteParamvol::
+~G4GDMLWriteParamvol()
+{
+}
 
 void G4GDMLWriteParamvol::
Index: trunk/source/persistency/gdml/src/G4GDMLWriteSetup.cc
===================================================================
--- trunk/source/persistency/gdml/src/G4GDMLWriteSetup.cc	(revision 1227)
+++ trunk/source/persistency/gdml/src/G4GDMLWriteSetup.cc	(revision 1228)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4GDMLWriteSetup.cc,v 1.11 2008/07/16 15:46:34 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// $Id: G4GDMLWriteSetup.cc,v 1.13 2009/04/24 15:34:20 gcosmo Exp $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // class G4GDMLWriteSetup Implementation
@@ -35,4 +35,14 @@
 
 #include "G4GDMLWriteSetup.hh"
+
+#include "G4LogicalVolume.hh"
+
+G4GDMLWriteSetup::G4GDMLWriteSetup() : G4GDMLWriteSolids()
+{
+}
+
+G4GDMLWriteSetup::~G4GDMLWriteSetup()
+{
+}
 
 void G4GDMLWriteSetup::SetupWrite(xercesc::DOMElement* gdmlElement,
Index: trunk/source/persistency/gdml/src/G4GDMLWriteSolids.cc
===================================================================
--- trunk/source/persistency/gdml/src/G4GDMLWriteSolids.cc	(revision 1227)
+++ trunk/source/persistency/gdml/src/G4GDMLWriteSolids.cc	(revision 1228)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4GDMLWriteSolids.cc,v 1.59 2008/11/21 09:32:46 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// $Id: G4GDMLWriteSolids.cc,v 1.65 2009/04/24 15:34:20 gcosmo Exp $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // class G4GDMLWriteSolids Implementation
@@ -36,8 +36,51 @@
 #include "G4GDMLWriteSolids.hh"
 
+#include "G4BooleanSolid.hh"
+#include "G4Box.hh"
+#include "G4Cons.hh"
+#include "G4Ellipsoid.hh"
+#include "G4EllipticalCone.hh"
+#include "G4EllipticalTube.hh"
+#include "G4ExtrudedSolid.hh"
+#include "G4Hype.hh"
+#include "G4Orb.hh"
+#include "G4Para.hh"
+#include "G4Paraboloid.hh"
+#include "G4IntersectionSolid.hh"
+#include "G4Polycone.hh"
+#include "G4Polyhedra.hh"
+#include "G4ReflectedSolid.hh"
+#include "G4Sphere.hh"
+#include "G4SubtractionSolid.hh"
+#include "G4TessellatedSolid.hh"
+#include "G4Tet.hh"
+#include "G4Torus.hh"
+#include "G4Trap.hh"
+#include "G4Trd.hh"
+#include "G4Tubs.hh"
+#include "G4TwistedBox.hh"
+#include "G4TwistedTrap.hh"
+#include "G4TwistedTrd.hh"
+#include "G4TwistedTubs.hh"
+#include "G4UnionSolid.hh"
+#include "G4OpticalSurface.hh"
+#include "G4SurfaceProperty.hh"
+
+G4GDMLWriteSolids::
+G4GDMLWriteSolids() : G4GDMLWriteMaterials()
+{
+}
+
+G4GDMLWriteSolids::
+~G4GDMLWriteSolids()
+{
+}
+
 void G4GDMLWriteSolids::
 BooleanWrite(xercesc::DOMElement* solidsElement,
              const G4BooleanSolid* const boolean)
 {
+   G4int displaced=0;
+
    G4String tag("undefined");
    if (dynamic_cast<const G4IntersectionSolid*>(boolean))
@@ -53,18 +96,52 @@
    G4ThreeVector firstpos,firstrot,pos,rot;
 
-   if (const G4DisplacedSolid* disp
-       = dynamic_cast<const G4DisplacedSolid*>(firstPtr))
-   {   
-      firstpos = disp->GetObjectTranslation();
-      firstrot = GetAngles(disp->GetObjectRotation());
-      firstPtr = disp->GetConstituentMovedSolid();
-   }
-
-   if (const G4DisplacedSolid* disp
-       = dynamic_cast<const G4DisplacedSolid*>(secondPtr))
-   {
-      pos = disp->GetObjectTranslation();
-      rot = GetAngles(disp->GetObjectRotation());
-      secondPtr = disp->GetConstituentMovedSolid();
+   // Solve possible displacement of referenced solids!
+   //
+   while (true)
+   {
+      if ( displaced>8 )
+      {
+        G4String ErrorMessage = "The referenced solid '"
+                              + firstPtr->GetName() +
+                              + "in the Boolean shape '" +
+                              + boolean->GetName() +
+                              + "' was displaced too many times!";
+        G4Exception("G4GDMLWriteSolids::BooleanWrite()",
+                    "InvalidSetup", FatalException, ErrorMessage);
+      }
+
+      if (G4DisplacedSolid* disp = dynamic_cast<G4DisplacedSolid*>(firstPtr))
+      {
+         firstpos += disp->GetObjectTranslation();
+         firstrot += firstrot + GetAngles(disp->GetObjectRotation());
+         firstPtr = disp->GetConstituentMovedSolid();
+         displaced++;
+         continue;
+      }
+      break;
+   }
+   displaced = 0;
+   while (true)
+   {
+      if ( displaced>maxTransforms )
+      {
+        G4String ErrorMessage = "The referenced solid '"
+                              + secondPtr->GetName() +
+                              + "in the Boolean shape '" +
+                              + boolean->GetName() +
+                              + "' was displaced too many times!";
+        G4Exception("G4GDMLWriteSolids::BooleanWrite()",
+                    "InvalidSetup", FatalException, ErrorMessage);
+      }
+
+      if (G4DisplacedSolid* disp = dynamic_cast<G4DisplacedSolid*>(secondPtr))
+      {
+         pos += disp->GetObjectTranslation();
+         rot += GetAngles(disp->GetObjectRotation());
+         secondPtr = disp->GetConstituentMovedSolid();
+         displaced++;
+         continue;
+      }
+      break;
    }
 
@@ -727,4 +804,21 @@
    zplaneElement->setAttributeNode(NewAttribute("rmax",rmax/mm));
    element->appendChild(zplaneElement);
+}
+
+void G4GDMLWriteSolids::
+OpticalSurfaceWrite(xercesc::DOMElement* solidsElement,
+                    const G4OpticalSurface* const surf)
+{
+   xercesc::DOMElement* optElement = NewElement("opticalsurface");
+   G4OpticalSurfaceModel smodel = surf->GetModel();
+   G4double sval = (smodel==glisur) ? surf->GetPolish() : surf->GetSigmaAlpha();
+
+   optElement->setAttributeNode(NewAttribute("name", surf->GetName()));
+   optElement->setAttributeNode(NewAttribute("model", smodel));
+   optElement->setAttributeNode(NewAttribute("finish", surf->GetFinish()));
+   optElement->setAttributeNode(NewAttribute("type", surf->GetType()));
+   optElement->setAttributeNode(NewAttribute("value", sval));
+
+   solidsElement->appendChild(optElement);
 }
 
@@ -822,6 +916,7 @@
    else
    {
-     G4String error_msg = "Unknown solid: " + solidPtr->GetName();
-     G4Exception("G4GDMLWriteSolids::AddSolid()", "ReadError",
+     G4String error_msg = "Unknown solid: " + solidPtr->GetName()
+                        + "; Type: " + solidPtr->GetEntityType();
+     G4Exception("G4GDMLWriteSolids::AddSolid()", "WriteError",
                  FatalException, error_msg);
    }
